//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  vpeB^O
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2013N0106 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    ListView1: TListView;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Caption := 'GDI+  摜t@C̃^vpeB';

  ListView1.Font.Size := 9;
  ListView1.GridLines := True;
  ListView1.Columns[0].Width := 220;
  ListView1.Columns[1].Width := 60;
  ListView1.Columns[2].Width := 180;
  ListView1.Columns[3].Width := 70;
end;

//=============================================================================
//  摜t@C̃^f[^̃vpeB^OXg
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LImageFilePath : String;
  LGPImage       : TGPImage;
  LSize          : UINT;
  LCount         : UINT;
  LPropItemArray : array of TPropertyItem;
  LpPropItem     : PPropertyItem;
  LStrTag        : string;
  LStrTagType    : string;
  LListItem      : TListItem;
  i              : Integer;
begin
  //摜t@Cǂݍ
  LImageFilePath := '';
  if OpenDialog1.InitialDir = '' then begin
    OpenDialog1.InitialDir := ExtractFileDir(ExtractFileDir(ParamStr(0)));
  end;

  OpenDialog1.Filter := '摜t@C|*.png;*.jpg;*.jpeg;*.bmp;*.gif';
  if OpenDialog1.Execute then begin
    OpenDialog1.InitialDir := ExtractFileDir(OpenDialog1.FileName);
    LImageFilePath := OpenDialog1.FileName;
  end;
  if LImageFilePath = '' then exit;
  Panel1.Caption := ExtractFileName(LImageFilePath);


  //摜t@CTGPImage𐶐
  LGPImage := TGPImage.Create(LImageFilePath);
  
  LSize  := 0;
  LCount := 0;
  //vpeB̃oCgTCYƐ擾āC̃̕m
  LGPImage.GetPropertySize(LSize, LCount);
  GetMem(Pointer(LPropItemArray), LSize);
  try
    //0ŃNAđSẴvpeBPropItemArrayɎ擾
    ZeroMemory(Pointer(LPropItemArray), LSize);
    LGPImage.GetAllPropertyItems(LSize, LCount, Pointer(LPropItemArray));

    //GDIPUTIL.pas̊֐gp
    //vpeB̒萔萔̕擾TListViewɒǉĂ
    ListView1.Items.Clear;
    ListView1.Items.BeginUpdate;
    for i := 0 to LCount - 1 do begin
      LpPropItem := @LPropItemArray[i];

      LStrTag     := GDIPUTIL.GetMetaDataIDString(LpPropItem^.id);
      LStrTagType := GDIPUTIL.ValueTypeFromULONG(LpPropItem^.type_);

      if LStrTag = '' then Continue;
      if (Pos('UnKnown', LStrTag) > 0)     then Continue;
      if (Pos('UnKnown', LStrTagType) > 0) then Continue;
      if (Pos('Nothing', LStrTagType) > 0) then Continue;

      LListItem := ListView1.Items.Add;
      LListItem.Caption :=  LStrTag;
      LListItem.SubItems.Add(Format('$%.4x', [LpPropItem^.id]));
      LListItem.SubItems.Add(LStrTagType);
      LListItem.SubItems.Add(IntToStr(LpPropItem^.length));

    end;
    ListView1.Items.EndUpdate;
  finally
    FreeMem(Pointer(LPropItemArray));
    LGPImage.Free;
  end;
end;

end.
