//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  vpeB^O  Delphi 2009 GDI+ Librarygp
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2013N0106 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, GDIPlus, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ListView1: TListView;
    OpenDialog1: TOpenDialog;
    Panel1: TPanel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Caption := 'GDI+  vpeBXg GDIPlus';

  ListView1.Font.Size := 9;
  ListView1.GridLines := True;
  ListView1.Columns[0].Width := 80;
  ListView1.Columns[1].Width := 80;
  ListView1.Columns[2].Width := 80;
end;

//=============================================================================
//  摜t@C̃^f[^̃vpeB^O̒lXg
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LImageFilePath : string;
  LGPImage       : IGPImage;
  LPropItem      : IGPPropertyItem;
  LListItem      : TListItem;
begin
  //摜t@Cǂݍ
  LImageFilePath := '';
  if OpenDialog1.InitialDir = '' then begin
    OpenDialog1.InitialDir := ExtractFileDir(ExtractFileDir(ParamStr(0)));
  end;

  OpenDialog1.Filter := '摜t@C|*.png;*.jpg;*.jpeg;*.bmp;*.gif';
  if OpenDialog1.Execute then begin
    OpenDialog1.InitialDir := ExtractFileDir(OpenDialog1.FileName);
    LImageFilePath := OpenDialog1.FileName;
  end;
  if LImageFilePath = '' then exit;
  Panel1.Caption := ExtractFileName(LImageFilePath);


  //摜t@CTGPImagẽCX^X𐶐
  LGPImage := TGPImage.Create(LImageFilePath);

  //vpeB̒萔lTListViewɒǉĂ
  ListView1.Items.Clear;
  ListView1.Items.BeginUpdate;
  for LPropItem in LGPImage.PropertyItems do begin
    LListItem := ListView1.Items.Add;
    LListItem.Caption :=  Format('$%.4x', [LPropItem.Id]);
    LListItem.SubItems.Add(IntToStr(LPropItem.ValueType));
    LListItem.SubItems.Add(IntToStr(LPropItem.Length));
  end;
  ListView1.Items.EndUpdate;
end;

end.
