//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  GPS̃^f[^̈ꕔ擾ĕ\
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2013N0108 `
//
//  2013N0721
//    E`̃vpeB̔zCIzgpɕύX
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Image1: TImage;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    LabeledEdit6: TLabeledEdit;
    LabeledEdit7: TLabeledEdit;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    FImageFilePath : string;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Caption := 'GDI+  fWJʐ^GPS (ꕔ)';
  FImageFilePath := '';
end;

//=============================================================================
//  [摜t@C]{^
//  摜t@CǂݍŁCGPS̃^f[^̈ꕔ擾ĕ\
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LGPImage        : TGPImage;
  LGPGraphic      : TGPGraphics;
  LAspectRatio    : Double;
  LpPropItem      : PPropertyItem;
  LIdValue        : Cardinal;
  LBufferSize     : Cardinal;
  LVersionValue   : PByte;
  LRationalValue  : array of Cardinal;
  LLatitudeDouble : Double;
begin
  //摜t@Cǂݍ
  FImageFilePath := '';
  if OpenDialog1.InitialDir = '' then begin
    OpenDialog1.InitialDir := ExtractFileDir(ExtractFileDir(ParamStr(0)));
  end;

  OpenDialog1.Filter := '摜t@C|*.png;*.jpg;*.jpeg;*.bmp;*.gif;*.tif;*.tiff';
  if OpenDialog1.Execute then begin
    OpenDialog1.InitialDir := ExtractFileDir(OpenDialog1.FileName);
    FImageFilePath := OpenDialog1.FileName;
  end;
  if FImageFilePath = '' then exit;


  //摜t@CTGPImagẽCX^X𐶐
  LGPImage := TGPBitmap.Create(FImageFilePath);

  //摜TImageɕ\(ǂȉ摜̊mFp)
  Image1.Picture.Assign(nil);
  LAspectRatio := LGPImage.GetHeight / LGPImage.GetWidth;
  Image1.SetBounds(Image1.Left,
                   Image1.Top,
                   Image1.Width,
                   Round(Image1.Width * LAspectRatio));

  LGPGraphic := TGPGraphics.Create(Image1.Canvas.Handle);
  LGPGraphic.DrawImage(LGPImage, 0, 0, Image1.Width, Image1.Height);


  LabeledEdit1.Text := '';
  LabeledEdit2.Text := '';
  LabeledEdit3.Text := '';
  LabeledEdit4.Text := '';
  LabeledEdit5.Text := '';
  LabeledEdit6.Text := '';
  LabeledEdit7.Text := '';

  //GPSIFD̃o[W
  //^f[^擾p̃obt@mۂC̃obt@ǂݎ
  //̃obt@̊i[`TPropertyItem(|C^^PPropertyItem)
  LIdValue := PropertyTagGpsVer;
  LBufferSize := LGPImage.GetPropertyItemSize(LIdValue);
  if LBufferSize > 0 then begin
    GetMem(LpPropItem, LBufferSize);
    try
      LGPImage.GetPropertyItem(LIdValue, LBufferSize, LpPropItem);
      if LpPropItem^.type_ = PropertyTagTypeByte then begin
        LVersionValue     := LpPropItem^.value;
        LabeledEdit1.Text := IntToStr(LVersionValue[0]) + ' ' +
                             IntToStr(LVersionValue[1]) + ' ' +
                             IntToStr(LVersionValue[2]) + ' ' +
                             IntToStr(LVersionValue[3]);
      end;
    finally
      FreeMem(LpPropItem);
    end;
  end;

  //ܓxk삩
  LIdValue    := PropertyTagGpsLatitudeRef;
  LBufferSize := LGPImage.GetPropertyItemSize(LIdValue);
  if LBufferSize > 0 then begin
    GetMem(LpPropItem, LBufferSize);
    try
      LGPImage.GetPropertyItem(LIdValue, LBufferSize, LpPropItem);
      if LpPropItem^.type_ = PropertyTagTypeASCII then begin
        LabeledEdit2.Text := string(PAnsiChar(LpPropItem^.value));
      end;
    finally
      FreeMem(LpPropItem);
    end;
  end;

  //ܓx
  //ܓxƌox́CxbƂɕ`Ŋi[Ă
  LIdValue    := PropertyTagGpsLatitude;
  LBufferSize := LGPImage.GetPropertyItemSize(LIdValue);
  if LBufferSize > 0 then begin
    GetMem(LpPropItem, LBufferSize);
    try
      LGPImage.GetPropertyItem(LIdValue, LBufferSize, LpPropItem);
      if LpPropItem^.type_ = PropertyTagTypeRational then begin
        //ƕq1gȂ̂Ŕzvf6Kv
        SetLength(LRationalValue, 6);
        LRationalValue    := LpPropItem^.value;
        LabeledEdit3.Text := IntToStr(LRationalValue[0]) + ' / ' +
                             IntToStr(LRationalValue[1]) + ' ' +
                             IntToStr(LRationalValue[2]) + ' / ' +
                             IntToStr(LRationalValue[3]) + ' ' +
                             IntToStr(LRationalValue[4]) + ' / ' +
                             IntToStr(LRationalValue[5]);

       //ܓx̒lɕϊĕ\
       LLatitudeDouble := LRationalValue[0] / LRationalValue[1] +
                         LRationalValue[2] / LRationalValue[3] / 60.0 +
                         LRationalValue[4] / LRationalValue[5] / 3600.0;
        LabeledEdit4.Text := FormatFloat('#0.000000000', LLatitudeDouble);
      end;
    finally
      FreeMem(LpPropItem);
    end;
  end;

  //ox
  LIdValue    := PropertyTagGpsLongitudeRef;
  LBufferSize := LGPImage.GetPropertyItemSize(LIdValue);
  if LBufferSize > 0 then begin
    GetMem(LpPropItem, LBufferSize);
    try
      LGPImage.GetPropertyItem(LIdValue, LBufferSize, LpPropItem);
      if LpPropItem^.type_ = PropertyTagTypeASCII then begin
        LabeledEdit5.Text := string(PAnsiChar(LpPropItem^.value));
      end;
    finally
      FreeMem(LpPropItem);
    end;
  end;

  //ox
  //ܓxƌox́CxbƂɕ`Ŋi[Ă
  LIdValue    := PropertyTagGpsLongitude;
  LBufferSize := LGPImage.GetPropertyItemSize(LIdValue);
  if LBufferSize > 0 then begin
    GetMem(LpPropItem, LBufferSize);
    try
      LGPImage.GetPropertyItem(LIdValue, LBufferSize, LpPropItem);
      if LpPropItem^.type_ = PropertyTagTypeRational then begin
        //ƕq1gȂ̂Ŕzvf6Kv
        SetLength(LRationalValue, 6);
        LRationalValue    := LpPropItem^.value;
        LabeledEdit6.Text := IntToStr(LRationalValue[0]) + ' / ' +
                             IntToStr(LRationalValue[1]) + ' ' +
                             IntToStr(LRationalValue[2]) + ' / ' +
                             IntToStr(LRationalValue[3]) + ' ' +
                             IntToStr(LRationalValue[4]) + ' / ' +
                             IntToStr(LRationalValue[5]);

       //ox̒lɕϊĕ\
       LLatitudeDouble := LRationalValue[0] / LRationalValue[1] +
                         LRationalValue[2] / LRationalValue[3] / 60.0 +
                         LRationalValue[4] / LRationalValue[5] / 3600.0;
        LabeledEdit7.Text := FormatFloat('#0.000000000', LLatitudeDouble);
      end;
    finally
      FreeMem(LpPropItem);
    end;
  end;

  LGPGraphic.Free;
  LGPImage.Free;
end;

end.
