//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  t@C̃vpeB
//  l̎擾EύX()Eڍ폜
//  Windows 7 [t@C̃vpeB]_CAO̕\ڂɂ͔Ή
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2013N0106 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL, ComCtrls, ExtCtrls, ActiveX;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    Image1: TImage;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    FImageFilePath : string;
    FMemStream     : TMemoryStream;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Caption  := 'GDI+  t@C̃vpeB';
  FImageFilePath := '';
end;

//=============================================================================
//  tH[OnDestroyCxg
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(FMemStream) then FreeAndNil(FMemStream);
end;

//=============================================================================
//  [摜t@C]{^
//  摜t@CǂݍŁC^f[^擾ĕ\
//
//  ̃Tvł́C摜t@C[㏑ۑ]\ɂ邽߂ɁC
//  (1) 摜Xg[Ɋi[
//  (2) 摜̃CX^XTGPImage͉
//  (3) ̃{^ł̑ł́CXg[TGPImage𐶐
//  (4) TGPImageCǂݏõt@Cŕۑ
//  ƂĂ
//  摜\KvȂ΁C
//  FMemStream.LoadFromFile(FImageFilePath);
//  ƂāCŏ烁Xg[ɉ摜i[Ă悢
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LGPImage       : TGPImage;
  LGPGraphic     : TGPGraphics;
  LAspectRatio   : Double;
  LSize          : UINT;
  LCount         : UINT;
  LPropItemArray : array of TPropertyItem;
  LpPropItem     : PPropertyItem;
  LIdValue       : Cardinal;
  LBufferSize    : Cardinal;
  LBuffer        : WideString;
  LImageGUID     : TGUID;
  i              : Integer;
begin
  //摜t@Cǂݍ
  FImageFilePath := '';
  if OpenDialog1.InitialDir = '' then begin
    OpenDialog1.InitialDir := ExtractFileDir(ExtractFileDir(ParamStr(0)));
  end;

  OpenDialog1.Filter := '摜t@C|*.png;*.jpg;*.jpeg;*.bmp;*.gif';
  if OpenDialog1.Execute then begin
    OpenDialog1.InitialDir := ExtractFileDir(OpenDialog1.FileName);
    FImageFilePath := OpenDialog1.FileName;
  end;
  if FImageFilePath = '' then exit;


  //摜t@CTGPImagẽCX^X𐶐
  LGPImage := TGPBitmap.Create(FImageFilePath);

  //摜TImageɕ\(ǂȉ摜̊mFp)
  Image1.Picture.Assign(nil);
  LAspectRatio := LGPImage.GetHeight / LGPImage.GetWidth;
  Image1.SetBounds(Image1.Left, Image1.Top, Image1.Width,
                                            Round(Image1.Width * LAspectRatio));
  LGPGraphic := TGPGraphics.Create(Image1.Canvas.Handle);
  LGPGraphic.DrawImage(LGPImage, 0, 0, Image1.Width, Image1.Height);


  LabeledEdit1.Text := '';
  LabeledEdit2.Text := '';
  LabeledEdit3.Text := '';
  LabeledEdit4.Text := '';
  LabeledEdit5.Text := '';

  LSize  := 0;
  LCount := 0;
  //vpeB̃oCgTCYƐ擾āC̃̕m
  LGPImage.GetPropertySize(LSize, LCount);

  //^f[^擾p̃obt@mۂC̃obt@ǂݎ
  //̃obt@̊i[`TPropertyItem(|C^^PPropertyItem)
  GetMem(Pointer(LPropItemArray), LSize);
  try
    //0ŃNAđSẴvpeBPropItemArrayɎ擾
    ZeroMemory(Pointer(LPropItemArray), LSize);
    LGPImage.GetAllPropertyItems(LSize, LCount, Pointer(LPropItemArray));

    //vpeBāCYvpeB̎
    for i := 0 to LCount - 1 do begin
      LpPropItem   := @LPropItemArray[i];
      LIdValue     := LpPropItem^.id;
      if (LIdValue >= $9C9B) and (LIdValue <= $9C9F) then begin
        LBufferSize := LpPropItem^.length;
        if LBufferSize > 0 then begin
          //obt@f[^擾D擾̒ݒ
          //ݒ肵ȂƃS~
          LBuffer := PWideChar(LpPropItem^.value);
          SetLength(LBuffer, LBufferSize div SizeOf(Char));
          case LIdValue of
            $9C9B : LabeledEdit1.Text := String(LBuffer);
            $9C9F : LabeledEdit2.Text := LBuffer;
            $9C9E : LabeledEdit3.Text := LBuffer;
            $9C9C : LabeledEdit4.Text := LBuffer;
            $9C9D : LabeledEdit5.Text := LBuffer;
          end;
        end;
      end;
    end;
  finally
    FreeMem(Pointer(LPropItemArray));
  end;

  //[㏑ۑ]\ɂ邽߂ɉ摜JPEG摜ƂăXg[Ɋi[
  //Xg[ɒڂ͊i[łȂ̂ŁCIStream𒇉
  if Assigned(FMemStream) then FreeAndNil(FMemStream);
  FMemStream := TMemoryStream.Create;
  if GetEncoderClsid('image/jpeg', LImageGUID) >= 0 then begin
    LGPImage.Save(TStreamAdapter.Create(FMemStream), LImageGUID);
  end;

  LGPGraphic.Free;
  LGPImage.Free;
end;

//=============================================================================
//  [㏑ۑ]{^
//  eTLabelEdit̒lŁCvpeBݒ肵āC^f[^Ƃĕۑ
//
//  Dephi 2009ȍ~ł΁CWideStringstringCPWideCharPCharł悢
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LIStrema   : IStream;
  LGPImage   : TGPImage;
  LPropItem  : TPropertyItem;
  LStrItem   : WideString;
  LImageGUID : TGUID;
begin
  if not Assigned(FMemStream) then exit;

  //摜IStreamăXg[ǂݏoCTGPImage𐶐
  //Xg[͒ڐłȂ̂Œ
  LIStrema := TStreamAdapter.Create(FMemStream);
  LGPImage := TGPBitmap.Create(LIStrema);

  //[^Cg]
  if Trim(LabeledEdit1.Text) <> '' then begin
    //R[h(R[hy[W)̏mɂɂ́CUϐɑ悢
    LStrItem := LabeledEdit1.Text;

    //TPropertyItemR[h^̃o[ɒlāCvpeBZbg
    LPropItem.id     := $9C9B;
    LPropItem.type_  := PropertyTagTypeByte;
    LPropItem.value  := PWideChar(LStrItem);
    LPropItem.length := Length(LStrItem) * SizeOf(Char) + 1;
    LGPImage.SetPropertyItem(LPropItem);
  end;

  //[\]
  if Trim(LabeledEdit2.Text) <> '' then begin
    LStrItem := LabeledEdit2.Text;

    LPropItem.id     := $9C9F;
    LPropItem.type_  := PropertyTagTypeByte;
    LPropItem.value  := PWideChar(LStrItem);
    LPropItem.length := Length(LStrItem) * SizeOf(Char) + 1;
    LGPImage.SetPropertyItem(LPropItem);
  end;

  //[L[[h]
  if Trim(LabeledEdit3.Text) <> '' then begin
    LStrItem := LabeledEdit3.Text;

    LPropItem.id     := $9C9E;
    LPropItem.type_  := PropertyTagTypeByte;
    LPropItem.value  := PWideChar(LStrItem);
    LPropItem.length := Length(LStrItem) * SizeOf(Char) + 1;
    LGPImage.SetPropertyItem(LPropItem);
  end;

  //[Rg]
  if Trim(LabeledEdit4.Text) <> '' then begin
    LStrItem := LabeledEdit4.Text;

    LPropItem.id     := $9C9C;
    LPropItem.type_  := PropertyTagTypeByte;
    LPropItem.value  := PWideChar(LStrItem);
    LPropItem.length := Length(LStrItem) * SizeOf(Char) + 1;
    LGPImage.SetPropertyItem(LPropItem);
  end;

  //[쐬]
  if Trim(LabeledEdit5.Text) <> '' then begin
    LStrItem := LabeledEdit5.Text;

    LPropItem.id     := $9C9D;
    LPropItem.type_  := PropertyTagTypeByte;
    LPropItem.value  := PWideChar(LStrItem);
    LPropItem.length := Length(LStrItem) * SizeOf(Char) + 1;
    LGPImage.SetPropertyItem(LPropItem);
  end;

  //ǂݏoƓt@CŁCJPEG摜Ƃď㏑ۑ
  if GetEncoderClsid('image/jpeg', LImageGUID) >= 0 then begin
    LGPImage.Save(FImageFilePath, LImageGUID);
  end;

  LGPImage.Free;
end;

//=============================================================================
//  [vpeB폜ĕۑ]{^
//=============================================================================
procedure TForm1.Button3Click(Sender: TObject);
var
  LIStrema   : IStream;
  LGPImage   : TGPImage;
  LImageGUID : TGUID;
begin
  if not Assigned(FMemStream) then exit;

  //摜IStreamăXg[ǂݏoCTGPImage𐶐
  //Xg[͒ڐłȂ̂Œ
  LIStrema := TStreamAdapter.Create(FMemStream);
  LGPImage := TGPBitmap.Create(LIStrema);

  LGPImage.RemovePropertyItem($9C9B);
  LGPImage.RemovePropertyItem($9C9C);
  LGPImage.RemovePropertyItem($9C9D);
  LGPImage.RemovePropertyItem($9C9E);
  LGPImage.RemovePropertyItem($9C9F);

  //ǂݏoƓt@CŁCJPEG摜Ƃď㏑ۑ
  if GetEncoderClsid('image/jpeg', LImageGUID) >= 0 then begin
    LGPImage.Save(FImageFilePath, LImageGUID);
  end;

  LGPImage.Free;
end;

end.