//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  t@C̃vpeB
//  l̎擾EύX()Eڍ폜  Delphi 2009 GDI+ Librarygp
//  Windows 7 [t@C̃vpeB]_CAO̕\ڂɂ͔Ή
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2013N0106 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, GDIPlus, ComCtrls, ExtCtrls, ActiveX;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Button2: TButton;
    Image1: TImage;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 錾 }
    FImageFilePath : string;
    FMemStream     : TMemoryStream;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Self.Caption  := 'GDI+  t@C̃vpeB GDIPlus';
  FImageFilePath := '';
end;

//=============================================================================
//  tH[OnDestroyCxg
//=============================================================================
procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(FMemStream) then FreeAndNil(FMemStream);
end;

//=============================================================================
//  [摜t@C]{^
//  摜t@CǂݍŁC^f[^擾ĕ\
//
//  ̃Tvł́C摜t@C[㏑ۑ]\ɂ邽߂ɁC
//  (1) 摜Xg[Ɋi[
//  (2) 摜̃CX^XTGPImage͉
//  (3) ̃{^ł̑ł́CXg[TGPImage𐶐
//  (4) TGPImageCǂݏõt@Cŕۑ
//  ƂĂ
//  摜\KvȂ΁C
//  FMemStream.LoadFromFile(FImageFilePath);
//  ƂāCŏ烁Xg[ɉ摜i[Ă悢
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LGPImage     : IGPImage;
  LGPGraphic   : IGPGraphics;
  LAspectRatio : Double;
  LPropItem    : IGPPropertyItem;
  LIdValue     : Cardinal;
  LBuffer      : string;
  LBufferSize  : Cardinal;
  i            : Integer;
begin
  //摜t@Cǂݍ
  FImageFilePath := '';
  if OpenDialog1.InitialDir = '' then begin
    OpenDialog1.InitialDir := ExtractFileDir(ExtractFileDir(ParamStr(0)));
  end;

  OpenDialog1.Filter := '摜t@C|*.png;*.jpg;*.jpeg;*.bmp;*.gif';
  if OpenDialog1.Execute then begin
    OpenDialog1.InitialDir := ExtractFileDir(OpenDialog1.FileName);
    FImageFilePath := OpenDialog1.FileName;
  end;
  if FImageFilePath = '' then exit;


  //摜t@CTGPImagẽCX^X𐶐
  LGPImage := TGPBitmap.Create(FImageFilePath);

  //摜TImageɕ\(ǂȉ摜̊mFp)
  Image1.Picture.Assign(nil);
  LAspectRatio := LGPImage.GetHeight / LGPImage.GetWidth;
  Image1.SetBounds(Image1.Left, Image1.Top, Image1.Width,
                                            Round(Image1.Width * LAspectRatio));
  LGPGraphic := TGPGraphics.Create(Image1.Canvas.Handle);
  LGPGraphic.DrawImage(LGPImage, 0, 0, Image1.Width, Image1.Height);


  LabeledEdit1.Text := '';
  LabeledEdit2.Text := '';
  LabeledEdit3.Text := '';
  LabeledEdit4.Text := '';
  LabeledEdit5.Text := '';

  //vpeBāCYvpeB̎
  for i := 0 to LGPImage.PropertyIdList.Count - 1 do begin
    LIdValue  := LGPImage.PropertyIdList[i];

    if (LIdValue >= $9C9B) and (LIdValue <= $9C9F) then begin
      //̍ڂTGPPropertyItemBufferɒl擾
      //Buffer̃oCgC̒擾̒ɂ
      //ݒ肵ȂƃS~
      LPropItem   := LGPImage.GetPropertyItem(LIdValue);
      LBuffer     := PChar(LPropItem.Value);
      LBufferSize := LPropItem.Length;
      SetLength(LBuffer, LBufferSize div SizeOf(Char));
      case LIdValue of
        $9C9B : LabeledEdit1.Text := LBuffer;
        $9C9F : LabeledEdit2.Text := LBuffer;
        $9C9E : LabeledEdit3.Text := LBuffer;
        $9C9C : LabeledEdit4.Text := LBuffer;
        $9C9D : LabeledEdit5.Text := LBuffer;
      end;
    end;
  end;

  //[㏑ۑ]\ɂ邽߂ɉ摜JPEG摜ƂăXg[Ɋi[
  //Xg[ɒڂ͊i[łȂ̂ŁCIStream𒇉
  if Assigned(FMemStream) then FreeAndNil(FMemStream);
  FMemStream := TMemoryStream.Create;
  LGPImage.Save(TStreamAdapter.Create(FMemStream), TGPImageFormat.Jpeg);
end;

//=============================================================================
//  [㏑ۑ]{^
//  eTLabelEdit̒lŁCvpeBݒ肵āC^f[^Ƃĕۑ
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LIStrema  : IStream;
  LGPImage  : IGPImage;
  LPropItem : IGPPropertyItem;
begin
  if not Assigned(FMemStream) then exit;

  //摜IStreamăXg[ǂݏoCTGPImage𐶐
  //Xg[͒ڐłȂ̂Œ
  LIStrema := TStreamAdapter.Create(FMemStream);
  LGPImage := TGPBitmap.Create(LIStrema);

  //[^Cg]
  if Trim(LabeledEdit1.Text) <> '' then begin
    //TGPPropertyItem̃CX^X𐶐CevpeB̒l
    LPropItem := TGPPropertyItem.Create;
    LPropItem.Id        := $9C9B;
    LPropItem.ValueType := PropertyTagTypeByte;
    LPropItem.Value     := PChar(LabeledEdit1.Text);
    LPropItem.Length    := Length(LabeledEdit1.Text) * SizeOf(Char) + 1;
    //vpeBZbg
    LGPImage.SetPropertyItem(LPropItem);
  end;

  //[\]
  if Trim(LabeledEdit2.Text) <> '' then begin
    LPropItem := TGPPropertyItem.Create;
    LPropItem.Id        := $9C9F;
    LPropItem.ValueType := PropertyTagTypeByte;
    LPropItem.Value     := PChar(LabeledEdit2.Text);
    LPropItem.Length    := Length(LabeledEdit2.Text) * SizeOf(Char) + 1;
    LGPImage.SetPropertyItem(LPropItem);
  end;

  //[L[[h
  if Trim(LabeledEdit3.Text) <> '' then begin
    LPropItem := TGPPropertyItem.Create;
    LPropItem.Id        := $9C9E;
    LPropItem.ValueType := PropertyTagTypeByte;
    LPropItem.Value     := PChar(LabeledEdit3.Text);
    LPropItem.Length    := Length(LabeledEdit3.Text) * SizeOf(Char) + 1;
    LGPImage.SetPropertyItem(LPropItem);
  end;

  //[Rg]
  if Trim(LabeledEdit4.Text) <> '' then begin
    LPropItem := TGPPropertyItem.Create;
    LPropItem.Id        := $9C9C;
    LPropItem.ValueType := PropertyTagTypeByte;
    LPropItem.Value     := PChar(LabeledEdit4.Text);
    LPropItem.Length    := Length(LabeledEdit4.Text) * SizeOf(Char) + 1;
    LGPImage.SetPropertyItem(LPropItem);
  end;

  //[쐬]
  if Trim(LabeledEdit5.Text) <> '' then begin
    LPropItem := TGPPropertyItem.Create;
    LPropItem.Id        := $9C9D;
    LPropItem.ValueType := PropertyTagTypeByte;
    LPropItem.Value     := PChar(LabeledEdit5.Text);
    LPropItem.Length    := Length(LabeledEdit5.Text) * SizeOf(Char) + 1;
    LGPImage.SetPropertyItem(LPropItem);
  end;

  //ǂݏoƓt@CŁCJPEG摜Ƃď㏑ۑ
  //̉摜JPEG`łȂꍇJPEGɕϊĕۑ
  FImageFilePath := ChangeFileExt(FImageFilePath, '.jpg');
  LGPImage.Save(FImageFilePath, TGPImageFormat.Jpeg);
end;

//=============================================================================
//  [vpeB폜ĕۑ]{^
//=============================================================================
procedure TForm1.Button3Click(Sender: TObject);
var
  LIStrema : IStream;
  LGPImage : IGPImage;
  LIdValue : Cardinal;
  i        : Integer;
begin
  if not Assigned(FMemStream) then exit;

  LGPImage := nil;
  //摜IStreamăXg[ǂݏoCTGPImage𐶐
  //Xg[͒ڐłȂ̂Œ
  LIStrema := TStreamAdapter.Create(FMemStream);
  LGPImage := TGPBitmap.Create(LIStrema);

  //vpeB̃XgCYvpeB̎ɁC̃vpeB폜
  for i := LGPImage.PropertyIdList.Count - 1 downto 0 do begin
    LIdValue := LGPImage.PropertyIdList[i];
    if (LIdValue >= $9C9B) and (LIdValue <= $9C9F) then begin
      LGPImage.RemovePropertyItem(LIdValue);
    end;
  end;

  //ǂݏoƓt@CŁCJPEG摜Ƃď㏑ۑ
  //̉摜JPEG`łȂꍇJPEGɕϊĕۑ
  FImageFilePath := ChangeFileExt(FImageFilePath, '.jpg');
  LGPImage.Save(FImageFilePath, TGPImageFormat.Jpeg);
end;

end.
